#include <stdlib.h>
#include <stdio.h>

#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
              
#include <sys/types.h>
#include <sys/mman.h>
#include <fcntl.h>           /* For O_* constants */

#define DISPLAY_C
#include "display.h"

/**
 Visualizza graficamente il frattale passato.
  \param rx risoluzione orizzontale
  \param ry risoluzione verticale
  \param m puntatore alla matrice. devono essere interi. -1=nero.
*/
int display(int rx,int ry,int*m){
 int s=shm_open(SHM_NAME,O_RDWR|O_CREAT,S_IRUSR|S_IWUSR);
 if(s==-1){perror("Cannot create POSIX Shared Memory segment\n");return -1;}
 if(write(s,&rx,sizeof(rx))==-1){perror("Error writing to Shared Memory\n");shm_unlink(SHM_NAME);return -1;}
 if(write(s,&ry,sizeof(ry))==-1){perror("Error writing to Shared Memory\n");shm_unlink(SHM_NAME);return -1;}
 if(write(s,m,sizeof(int)*rx*ry)==-1){perror("Error writing to Shared Memory\n");shm_unlink(SHM_NAME);return -1;}
 close(s);
 if(execl("./displayer","main",(char*)NULL)==-1){perror("Cannot exec displayer\n");return -1;}
 return -1;
}
